#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityTouchingFishTaskCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityTouchingFishTaskCFG> M_ActivityTouchingFishTaskCFG::msSingleton(nullptr);

int M_ActivityTouchingFishTaskCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityTouchingFishTaskCFGData* M_ActivityTouchingFishTaskCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityTouchingFishTaskCFGData>& M_ActivityTouchingFishTaskCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityTouchingFishTaskCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityTouchingFishTaskCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityTouchingFishTaskCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mFirstName = element->Attribute("FirstName");
		data.mName = element->Attribute("Name");
		data.mCompleteType = element->IntAttribute("CompleteType");
		data.mType = element->IntAttribute("Type");
		data.mGroup = element->IntAttribute("Group");
		data.mCompleteParam = element->IntAttribute("CompleteParam");
		data.mCompleteCount = element->IntAttribute("CompleteCount");
		data.mCompleteTimes = element->IntAttribute("CompleteTimes");
		{
			const char* RewardItem = element->Attribute("RewardItem");
			std::vector<std::string> vecRewardItem;
			boost::split(vecRewardItem, RewardItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardItem[i].c_str(), &temp))
				{
					data.mRewardItem.push_back(temp);
				}
			}
		}
		{
			const char* RewardQuantity = element->Attribute("RewardQuantity");
			std::vector<std::string> vecRewardQuantity;
			boost::split(vecRewardQuantity, RewardQuantity, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardQuantity.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardQuantity[i].c_str(), &temp))
				{
					data.mRewardQuantity.push_back(temp);
				}
			}
		}
		data.mGoType = element->IntAttribute("GoType");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityTouchingFishTaskCFG::Load()
{
	Load("../Config/M_ActivityTouchingFishTaskCFG.xml");
}

M_ActivityTouchingFishTaskCFG* M_ActivityTouchingFishTaskCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityTouchingFishTaskCFG());
	}
	return msSingleton.get();
}
